// (C) 2001-2024 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


`timescale 1ns / 100ps
module  bts_config (
        //Reset&Clock
        input  wire        cpu_1v2_resetn          , // Reset, low active
        input  wire        clk_sys_100m_p          , // System clock, 100MHz
        input  wire        clk_sys_bak_100m_p       , // System clock, 50MHz
        //I2C interfaces
	    inout  wire        si5518_i2c_scl           , // FPGA I2C interface #1 SCL
        inout  wire        si5518_i2c_sda           , // FPGA I2C interface #1 SDA
        //RDIMM I2C interfaces 
		inout  wire        fpga_dimm_scl            , // FPGA I2C interface #2 SCL
        inout  wire        fpga_dimm_sda            , // FPGA I2C interface #2 SDA
        //i2c 2
		inout  wire        si5395_i2c_scl           , // FPGA I2C interface dedicated for RDIMM access
        inout  wire        si5395_i2c_sda           , // FPGA I2C interface dedicated for RDIMM access
        //i2c 3
		inout  wire        fmca_i2c_scl             , // FPGA I2C interface dedicated for RDIMM access
        inout  wire        fmca_i2c_sda             , // FPGA I2C interface dedicated for RDIMM access
        //i2c 4 
		inout  wire        fmcb_i2c_scl             , // FPGA I2C interface dedicated for RDIMM access
        inout  wire        fmcb_i2c_sda             , // FPGA I2C interface dedicated for RDIMM access
        //i2c 5
		inout  wire        pca95350_i2c_scl           , // FPGA I2C interface dedicated for RDIMM access
        inout  wire        pca95350_i2c_sda           , // FPGA I2C interface dedicated for RDIMM access
        //i2c 6 
		inout  wire        pca95351_i2c_scl           , // FPGA I2C interface dedicated for RDIMM access
        inout  wire        pca95351_i2c_sda           , // FPGA I2C interface dedicated for RDIMM access
        //i2c 7-14
		inout  wire        qsfp0_i2c_scl           , // FPGA I2C interface dedicated for RDIMM access
        inout  wire        qsfp0_i2c_sda           , // FPGA I2C interface dedicated for RDIMM access
		inout  wire        qsfp1_i2c_scl           , // FPGA I2C interface dedicated for RDIMM access
        inout  wire        qsfp1_i2c_sda           , // FPGA I2C interface dedicated for RDIMM access
		inout  wire        qsfp2_i2c_scl           , // FPGA I2C interface dedicated for RDIMM access
        inout  wire        qsfp2_i2c_sda           , // FPGA I2C interface dedicated for RDIMM access
		inout  wire        osfp_i2c_scl           , // FPGA I2C interface dedicated for RDIMM access
        inout  wire        osfp_i2c_sda           , // FPGA I2C interface dedicated for RDIMM access
		inout  wire        sfp0_i2c_scl           , // FPGA I2C interface dedicated for RDIMM access
        inout  wire        sfp0_i2c_sda           , // FPGA I2C interface dedicated for RDIMM access
		inout  wire        sfp1_i2c_scl           , // FPGA I2C interface dedicated for RDIMM access
        inout  wire        sfp1_i2c_sda           , // FPGA I2C interface dedicated for RDIMM access
		inout  wire        sfp2_i2c_scl           , // FPGA I2C interface dedicated for RDIMM access
        inout  wire        sfp2_i2c_sda           , // FPGA I2C interface dedicated for RDIMM access
		inout  wire        sfp3_i2c_scl           , // FPGA I2C interface dedicated for RDIMM access
        inout  wire        sfp3_i2c_sda           , // FPGA I2C interface dedicated for RDIMM access
     //SPI 
	    input  wire        spi_5518_MISO,   
        output wire        spi_5518_MOSI,   
        output wire        spi_5518_SCLK,   
        output wire        spi_5518_SS_n,   
		//SGPIO for dipsw, leds
        input  wire        fpga_sgpio_sync,
        input  wire        fpga_sgpio_clk ,
        input  wire        fpga_sgpi      ,    
        output wire        fpga_sgpo      ,
		output wire        si5395_1_1v2_a_oen        ,
		output wire        si5395_2_1v2_a_oen        ,
        //GPIOs
        output wire [2:0]  qsfp_sel,
		output wire [3:0]  qsfpdd_sel,
		output wire        qsfpdd800_sel,
        //GPIOs
		output wire [11:0] fpga_gpio                 // FPGA user LEDs
        //QSFPDD LEDs & control signals
//        output wire [2:0]  fpga_led_status         // Status LEDs
        );
wire        fpga_i2c_en ;
wire [2:0]  fpga_led_status ;
assign  qsfp_sel       =   3'b0;
assign  qsfpdd_sel      =   4'b0;
assign  qsfpdd800_sel   =   1'b0;
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Signal definitions
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
wire          ninit_done/* synthesis keep */;
wire          global_resetn/* synthesis keep */;
//i2c 0
wire          si5518_i2c_scl_in/* synthesis keep */;
wire          si5518_i2c_sda_in/* synthesis keep */;
wire          si5518_i2c_scl_oe/* synthesis keep */;
wire          si5518_i2c_sda_oe/* synthesis keep */;
//i2c 1
wire          fpga_dimm_scl_in/* synthesis keep */;
wire          fpga_dimm_sda_in/* synthesis keep */;
wire          fpga_dimm_scl_oe/* synthesis keep */;
wire          fpga_dimm_sda_oe/* synthesis keep */;
//i2c 2
wire          si5395_i2c_scl_in/* synthesis keep */;
wire          si5395_i2c_sda_in/* synthesis keep */;
wire          si5395_i2c_scl_oe/* synthesis keep */;
wire          si5395_i2c_sda_oe/* synthesis keep */;
//i2c 3 
wire          fmca_i2c_scl_in/* synthesis keep */;
wire          fmca_i2c_sda_in/* synthesis keep */;
wire          fmca_i2c_scl_oe/* synthesis keep */;
wire          fmca_i2c_sda_oe/* synthesis keep */;
//i2c 4
wire          fmcb_i2c_scl_in/* synthesis keep */;
wire          fmcb_i2c_sda_in/* synthesis keep */;
wire          fmcb_i2c_scl_oe/* synthesis keep */;
wire          fmcb_i2c_sda_oe/* synthesis keep */;
//i2c 5
wire          pca95350_i2c_scl_in/* synthesis keep */;
wire          pca95350_i2c_sda_in/* synthesis keep */;
wire          pca95350_i2c_scl_oe/* synthesis keep */;
wire          pca95350_i2c_sda_oe/* synthesis keep */;
//i2c 6 
wire          pca95351_i2c_scl_in/* synthesis keep */;
wire          pca95351_i2c_sda_in/* synthesis keep */;
wire          pca95351_i2c_scl_oe/* synthesis keep */;
wire          pca95351_i2c_sda_oe/* synthesis keep */;
//i2c 7-14
wire          qsfp0_i2c_scl_in/* synthesis keep */;
wire          qsfp0_i2c_sda_in/* synthesis keep */;
wire          qsfp0_i2c_scl_oe/* synthesis keep */;
wire          qsfp0_i2c_sda_oe/* synthesis keep */;
wire          qsfp1_i2c_scl_in/* synthesis keep */;
wire          qsfp1_i2c_sda_in/* synthesis keep */;
wire          qsfp1_i2c_scl_oe/* synthesis keep */;
wire          qsfp1_i2c_sda_oe/* synthesis keep */;
wire          qsfp2_i2c_scl_in/* synthesis keep */;
wire          qsfp2_i2c_sda_in/* synthesis keep */;
wire          qsfp2_i2c_scl_oe/* synthesis keep */;
wire          qsfp2_i2c_sda_oe/* synthesis keep */;
wire          osfp_i2c_scl_in/* synthesis keep */;
wire          osfp_i2c_sda_in/* synthesis keep */;
wire          osfp_i2c_scl_oe/* synthesis keep */;
wire          osfp_i2c_sda_oe/* synthesis keep */;
wire          sfp0_i2c_scl_in/* synthesis keep */;
wire          sfp0_i2c_sda_in/* synthesis keep */;
wire          sfp0_i2c_scl_oe/* synthesis keep */;
wire          sfp0_i2c_sda_oe/* synthesis keep */;
wire          sfp1_i2c_scl_in/* synthesis keep */;
wire          sfp1_i2c_sda_in/* synthesis keep */;
wire          sfp1_i2c_scl_oe/* synthesis keep */;
wire          sfp1_i2c_sda_oe/* synthesis keep */;
wire          sfp2_i2c_scl_in/* synthesis keep */;
wire          sfp2_i2c_sda_in/* synthesis keep */;
wire          sfp2_i2c_scl_oe/* synthesis keep */;
wire          sfp2_i2c_sda_oe/* synthesis keep */;
wire          sfp3_i2c_scl_in/* synthesis keep */;
wire          sfp3_i2c_sda_in/* synthesis keep */;
wire          sfp3_i2c_scl_oe/* synthesis keep */;
wire          sfp3_i2c_sda_oe/* synthesis keep */;
wire [31:0]   av_readdata_0/* synthesis keep */;
wire [31:0]   av_readdata_1/* synthesis keep */;
wire [31:0]   av_readdata_2/* synthesis keep */;
wire [31:0]   av_readdata_3/* synthesis keep */;
wire [31:0]   av_writedata_0/* synthesis keep */; // FPGA LED control
wire [31:0]   av_writedata_1/* synthesis keep */; // FPGA QSFPDD LED control
//wire [31:0] av_writedata_2/* synthesis keep */; // FPGA QSFPDD controller and module management
//wire [31:0] av_writedata_3/* synthesis keep */;
//wire [31:0] av_writedata_4/* synthesis keep */;
//wire [31:0] av_writedata_5/* synthesis keep */;
//wire [31:0] av_writedata_6/* synthesis keep */;
//wire [31:0] av_writedata_7/* synthesis keep */;
wire [1:0]    receiver_irq/* synthesis keep */;
reg [24:0]   led_counter/* synthesis keep */;
wire [7:0]      fpga_sw/* synthesis keep */;
wire [7:0]      fpga_led/* synthesis keep */;
wire  [15:0]	fpga_sw_pb/* synthesis keep */;
wire [5:0]      pio_export; // pio_0_external_connection.export
//----------------------------------------------------------------------------------------------------------
// Intel Agilex Reset Release
//----------------------------------------------------------------------------------------------------------
reset_release reset_release_inst 
              (
              .ninit_done (ninit_done)  // ninit_done.ninit_done, low active
              );
assign global_resetn = !ninit_done & cpu_1v2_resetn;
iopll iopll_u0 (
		.rst      (!cpu_1v2_resetn),      //   input,  width = 1, reset.reset
		.refclk   (clk_sys_100m_p),       //   input,  width = 1, refclk.clk
		.locked   (),                     //  output,  width = 1, locked.export
		.outclk_0 (clk_sys_100m) ,        //  output,  width = 1, outclk0.clk
		.outclk_1 (clk_sys_50m)           //  output,  width = 1, outclk1.clk
	);
//assign global_resetn = cpu_1v2_resetn;
assign si5395_1_1v2_a_oen   = 1'b0;
assign si5395_2_1v2_a_oen   = 1'b0;
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Qsys module
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
q_sys   q_sys_inst0 (
        .clk_100_clk                      (clk_sys_50m           ), //           clk_50.clk
        .reset_50_reset_n                 (global_resetn         ), //         reset_50.reset_n
        .i2c_0_i2c_serial_sda_in          (si5518_i2c_sda_in     ), // i2c_0_i2c_serial.sda_in
        .i2c_0_i2c_serial_scl_in          (si5518_i2c_scl_in     ), //                 .scl_in
        .i2c_0_i2c_serial_sda_oe          (si5518_i2c_sda_oe     ), //                 .sda_oe
        .i2c_0_i2c_serial_scl_oe          (si5518_i2c_scl_oe     ), //                 .scl_oe
        .i2c_1_i2c_serial_sda_in          (fpga_dimm_sda_in      ), // i2c_1_i2c_serial.sda_in
        .i2c_1_i2c_serial_scl_in          (fpga_dimm_scl_in      ), //                 .scl_in
        .i2c_1_i2c_serial_sda_oe          (fpga_dimm_sda_oe      ), //                 .sda_oe
        .i2c_1_i2c_serial_scl_oe          (fpga_dimm_scl_oe      ), //                 .scl_oe
        .i2c_2_i2c_serial_sda_in          (si5395_i2c_sda_in     ), // i2c_2_i2c_serial.sda_in
        .i2c_2_i2c_serial_scl_in          (si5395_i2c_scl_in     ), //                 .scl_in
        .i2c_2_i2c_serial_sda_oe          (si5395_i2c_sda_oe     ), //                 .sda_oe
        .i2c_2_i2c_serial_scl_oe          (si5395_i2c_scl_oe     ), //                 .scl_oe
        .i2c_3_i2c_serial_sda_in          (fmca_i2c_sda_in       ), // i2c_3_i2c_serial.sda_in
        .i2c_3_i2c_serial_scl_in          (fmca_i2c_scl_in       ), //                 .scl_in
        .i2c_3_i2c_serial_sda_oe          (fmca_i2c_sda_oe       ), //                 .sda_oe
        .i2c_3_i2c_serial_scl_oe          (fmca_i2c_scl_oe       ), //                 .scl_oe
        .i2c_4_i2c_serial_sda_in          (fmcb_i2c_sda_in       ), // i2c_4_i2c_serial.sda_in
        .i2c_4_i2c_serial_scl_in          (fmcb_i2c_scl_in       ), //                 .scl_in
        .i2c_4_i2c_serial_sda_oe          (fmcb_i2c_sda_oe       ), //                 .sda_oe
        .i2c_4_i2c_serial_scl_oe          (fmcb_i2c_scl_oe       ), //                 .scl_oe
        .i2c_5_i2c_serial_sda_in          (pca95350_i2c_sda_in     ), // i2c_5_i2c_serial.sda_in
        .i2c_5_i2c_serial_scl_in          (pca95350_i2c_scl_in     ), //                 .scl_in
        .i2c_5_i2c_serial_sda_oe          (pca95350_i2c_sda_oe     ), //                 .sda_oe
        .i2c_5_i2c_serial_scl_oe          (pca95350_i2c_scl_oe     ), //                 .scl_oe
        .i2c_6_i2c_serial_sda_in          (pca95351_i2c_sda_in      ), // i2c_6_i2c_serial.sda_in
        .i2c_6_i2c_serial_scl_in          (pca95351_i2c_scl_in      ), //                 .scl_in
        .i2c_6_i2c_serial_sda_oe          (pca95351_i2c_sda_oe      ), //                 .sda_oe
        .i2c_6_i2c_serial_scl_oe          (pca95351_i2c_scl_oe      ), //                 .scl_oe
        .i2c_7_i2c_serial_sda_in          (qsfp0_i2c_sda_in      ), // i2c_7_i2c_serial.sda_in
        .i2c_7_i2c_serial_scl_in          (qsfp0_i2c_scl_in      ), //                 .scl_in
        .i2c_7_i2c_serial_sda_oe          (qsfp0_i2c_sda_oe      ), //                 .sda_oe
        .i2c_7_i2c_serial_scl_oe          (qsfp0_i2c_scl_oe      ), //                 .scl_oe
        .i2c_8_i2c_serial_sda_in          (qsfp1_i2c_sda_in      ), // i2c_8_i2c_serial.sda_in
        .i2c_8_i2c_serial_scl_in          (qsfp1_i2c_scl_in      ), //                 .scl_in
        .i2c_8_i2c_serial_sda_oe          (qsfp1_i2c_sda_oe      ), //                 .sda_oe
        .i2c_8_i2c_serial_scl_oe          (qsfp1_i2c_scl_oe      ), //                 .scl_oe
        .i2c_9_i2c_serial_sda_in          (qsfp2_i2c_sda_in      ), // i2c_9_i2c_serial.sda_in
        .i2c_9_i2c_serial_scl_in          (qsfp2_i2c_scl_in      ), //                 .scl_in
        .i2c_9_i2c_serial_sda_oe          (qsfp2_i2c_sda_oe      ), //                 .sda_oe
        .i2c_9_i2c_serial_scl_oe          (qsfp2_i2c_scl_oe      ), //                 .scl_oe
        .i2c_10_i2c_serial_sda_in         (osfp_i2c_sda_in      ), // i2c_10_i2c_serial.sda_in
        .i2c_10_i2c_serial_scl_in         (osfp_i2c_scl_in      ), //                 .scl_in
        .i2c_10_i2c_serial_sda_oe         (osfp_i2c_sda_oe      ), //                 .sda_oe
        .i2c_10_i2c_serial_scl_oe         (osfp_i2c_scl_oe      ), //                 .scl_oe
        .i2c_11_i2c_serial_sda_in         (sfp0_i2c_sda_in      ), // i2c_11_i2c_serial.sda_in
        .i2c_11_i2c_serial_scl_in         (sfp0_i2c_scl_in      ), //                 .scl_in
        .i2c_11_i2c_serial_sda_oe         (sfp0_i2c_sda_oe      ), //                 .sda_oe
        .i2c_11_i2c_serial_scl_oe         (sfp0_i2c_scl_oe      ), //                 .scl_oe
        .i2c_12_i2c_serial_sda_in         (sfp1_i2c_sda_in      ), // i2c_12_i2c_serial.sda_in
        .i2c_12_i2c_serial_scl_in         (sfp1_i2c_scl_in      ), //                 .scl_in
        .i2c_12_i2c_serial_sda_oe         (sfp1_i2c_sda_oe      ), //                 .sda_oe
        .i2c_12_i2c_serial_scl_oe         (sfp1_i2c_scl_oe      ), //                 .scl_oe
        .i2c_13_i2c_serial_sda_in         (sfp2_i2c_sda_in      ), // i2c_13_i2c_serial.sda_in
        .i2c_13_i2c_serial_scl_in         (sfp2_i2c_scl_in      ), //                 .scl_in
        .i2c_13_i2c_serial_sda_oe         (sfp2_i2c_sda_oe      ), //                 .sda_oe
        .i2c_13_i2c_serial_scl_oe         (sfp2_i2c_scl_oe      ), //                 .scl_oe
        .i2c_14_i2c_serial_sda_in         (sfp3_i2c_sda_in      ), // i2c_14_i2c_serial.sda_in
        .i2c_14_i2c_serial_scl_in         (sfp3_i2c_scl_in      ), //                 .scl_in
        .i2c_14_i2c_serial_sda_oe         (sfp3_i2c_sda_oe      ), //                 .sda_oe
        .i2c_14_i2c_serial_scl_oe         (sfp3_i2c_scl_oe      ), //                 .scl_oe
//        .i2c_15_i2c_serial_sda_in         (i2c_sda_in      ), // i2c_15_i2c_serial.sda_in
//        .i2c_15_i2c_serial_scl_in         (i2c_scl_in      ), //                 .scl_in
//        .i2c_15_i2c_serial_sda_oe         (i2c_sda_oe      ), //                 .sda_oe
//        .i2c_15_i2c_serial_scl_oe         (i2c_scl_oe      ), //                 .scl_oe
        .pio_0_led_external_connection_export     (pio_export           ), // pio_0_external_connection.export
		.pio_1_user_sw_external_connection_export (fpga_sw_pb[15:8]              ), // pio_1_user_sw_external_connection.export
		.pio_2_user_pb_external_connection_export ({fpga_sw_pb[1],fpga_sw_pb[0]} ), // pio_2_user_pb_external_connection.export
        .spi_0_external_MISO  (spi_5518_MISO),   //                     spi_0_external.MISO
        .spi_0_external_MOSI  (spi_5518_MOSI),   //                                   .MOSI
        .spi_0_external_SCLK  (spi_5518_SCLK),   //                                   .SCLK
        .spi_0_external_SS_n  (spi_5518_SS_n),   //                                   .SS_n   
        .av_readdata_0_export             (av_readdata_0         ), //    av_readdata_0.export
        .av_readdata_1_export             (av_readdata_1         ), //    av_readdata_1.export
        .av_readdata_2_export             (av_readdata_2         ), //    av_readdata_2.export
        .av_readdata_3_export             (av_readdata_3         ), //    av_readdata_3.export
        .av_writedata_0_export            (av_writedata_0        ), //   av_writedata_0.export
        .av_writedata_1_export            (av_writedata_1        ), //   av_writedata_1.export
      //.av_writedata_2_export            (av_writedata_2        ), //   av_writedata_2.export
      //.av_writedata_3_export            (av_writedata_3        ), //   av_writedata_3.export
      //.av_writedata_4_export            (av_writedata_4        ), //   av_writedata_4.export
      //.av_writedata_5_export            (av_writedata_5        ), //   av_writedata_5.export
      //.av_writedata_6_export            (av_writedata_6        ), //   av_writedata_6.export
      //.av_writedata_7_export            (av_writedata_7        ), //   av_writedata_7.export
        .receiver_irq_irq                 (receiver_irq          )  //     receiver_irq.irq
	);
assign av_readdata_0   = {32'b0};
assign av_readdata_1   = 32'h00000000;
assign av_readdata_2   = 32'h00000000;
assign av_readdata_3   = 32'h00000000;
assign receiver_irq    = {2'b0};
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Output assignments control
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
assign si5518_i2c_scl_in     = si5518_i2c_scl;
assign si5518_i2c_sda_in     = si5518_i2c_sda;
assign si5518_i2c_scl        = si5518_i2c_scl_oe ? 1'b0 : 1'bz;
assign si5518_i2c_sda        = si5518_i2c_sda_oe ? 1'b0 : 1'bz;
assign fpga_dimm_scl_in      = fpga_dimm_scl;
assign fpga_dimm_sda_in      = fpga_dimm_sda;
assign fpga_dimm_scl         = fpga_dimm_scl_oe ? 1'b0 : 1'bz;
assign fpga_dimm_sda         = fpga_dimm_sda_oe ? 1'b0 : 1'bz;
assign si5395_i2c_scl_in     = si5395_i2c_scl;
assign si5395_i2c_sda_in     = si5395_i2c_sda;
assign si5395_i2c_scl        = si5395_i2c_scl_oe ? 1'b0 : 1'bz;
assign si5395_i2c_sda        = si5395_i2c_sda_oe ? 1'b0 : 1'bz;
assign fmca_i2c_scl_in       = fmca_i2c_scl;
assign fmca_i2c_sda_in       = fmca_i2c_sda;
assign fmca_i2c_scl          = fmca_i2c_scl_oe ? 1'b0 : 1'bz;
assign fmca_i2c_sda          = fmca_i2c_sda_oe ? 1'b0 : 1'bz;
assign fmcb_i2c_scl_in       = fmcb_i2c_scl;
assign fmcb_i2c_sda_in       = fmcb_i2c_sda;
assign fmcb_i2c_scl          = fmcb_i2c_scl_oe ? 1'b0 : 1'bz;
assign fmcb_i2c_sda          = fmcb_i2c_sda_oe ? 1'b0 : 1'bz;
assign pca95350_i2c_scl_in   = pca95350_i2c_scl;
assign pca95350_i2c_sda_in   = pca95350_i2c_sda;
assign pca95350_i2c_scl      = pca95350_i2c_scl_oe ? 1'b0 : 1'bz;
assign pca95350_i2c_sda      = pca95350_i2c_sda_oe ? 1'b0 : 1'bz;
assign pca95351_i2c_scl_in   = pca95351_i2c_scl;
assign pca95351_i2c_sda_in   = pca95351_i2c_sda;
assign pca95351_i2c_scl      = pca95351_i2c_scl_oe ? 1'b0 : 1'bz;
assign pca95351_i2c_sda      = pca95351_i2c_sda_oe ? 1'b0 : 1'bz;
assign qsfp0_i2c_scl_in   = qsfp0_i2c_scl;
assign qsfp0_i2c_sda_in   = qsfp0_i2c_sda;
assign qsfp0_i2c_scl      = qsfp0_i2c_scl_oe ? 1'b0 : 1'bz;
assign qsfp0_i2c_sda      = qsfp0_i2c_sda_oe ? 1'b0 : 1'bz;
assign qsfp1_i2c_scl_in   = qsfp1_i2c_scl;
assign qsfp1_i2c_sda_in   = qsfp1_i2c_sda;
assign qsfp1_i2c_scl      = qsfp1_i2c_scl_oe ? 1'b0 : 1'bz;
assign qsfp1_i2c_sda      = qsfp1_i2c_sda_oe ? 1'b0 : 1'bz;
assign qsfp2_i2c_scl_in   = qsfp2_i2c_scl;
assign qsfp2_i2c_sda_in   = qsfp2_i2c_sda;
assign qsfp2_i2c_scl      = qsfp2_i2c_scl_oe ? 1'b0 : 1'bz;
assign qsfp2_i2c_sda      = qsfp2_i2c_sda_oe ? 1'b0 : 1'bz;
assign osfp_i2c_scl_in   = osfp_i2c_scl;
assign osfp_i2c_sda_in   = osfp_i2c_sda;
assign osfp_i2c_scl      = osfp_i2c_scl_oe ? 1'b0 : 1'bz;
assign osfp_i2c_sda      = osfp_i2c_sda_oe ? 1'b0 : 1'bz;
assign sfp0_i2c_scl_in   = sfp0_i2c_scl;
assign sfp0_i2c_sda_in   = sfp0_i2c_sda;
assign sfp0_i2c_scl      = sfp0_i2c_scl_oe ? 1'b0 : 1'bz;
assign sfp0_i2c_sda      = sfp0_i2c_sda_oe ? 1'b0 : 1'bz;
assign sfp1_i2c_scl_in   = sfp1_i2c_scl;
assign sfp1_i2c_sda_in   = sfp1_i2c_sda;
assign sfp1_i2c_scl      = sfp1_i2c_scl_oe ? 1'b0 : 1'bz;
assign sfp1_i2c_sda      = sfp1_i2c_sda_oe ? 1'b0 : 1'bz;
assign sfp2_i2c_scl_in   = sfp2_i2c_scl;
assign sfp2_i2c_sda_in   = sfp2_i2c_sda;
assign sfp2_i2c_scl      = sfp2_i2c_scl_oe ? 1'b0 : 1'bz;
assign sfp2_i2c_sda      = sfp2_i2c_sda_oe ? 1'b0 : 1'bz;
assign sfp3_i2c_scl_in   = sfp3_i2c_scl;
assign sfp3_i2c_sda_in   = sfp3_i2c_sda;
assign sfp3_i2c_scl      = sfp3_i2c_scl_oe ? 1'b0 : 1'bz;
assign sfp3_i2c_sda      = sfp3_i2c_sda_oe ? 1'b0 : 1'bz;
assign fpga_i2c_en          = 1'b1;                            // DIPSW control externally
always @(posedge clk_sys_50m)
begin
	if (!cpu_1v2_resetn)
		led_counter <= 25'b0;
	else if (led_counter == 25'b1111111111111111111111111)
		led_counter <= ~led_counter;
	else
		led_counter <= led_counter + 1'b1;
end
assign fpga_led[0] = pio_export[0];
assign fpga_led[1] = pio_export[1];
assign fpga_led[2] = pio_export[2];
assign fpga_led[3] = pio_export[3];
assign fpga_led[4] = pio_export[4];
assign fpga_led[5] = pio_export[5];
assign fpga_led[6] = led_counter[20];
assign fpga_led[7] = led_counter[22];
//assign fpga_gpio[0] = led_counter[18] ;
//assign fpga_gpio[1] = led_counter[19]; 
//assign fpga_gpio[2] = led_counter[20];
//assign fpga_gpio[3] = led_counter[21];
//assign fpga_gpio[4] = led_counter[22];
//assign fpga_gpio[5] = led_counter[23];
//assign fpga_gpio[6] = led_counter[24];
//assign fpga_led[0]          = av_writedata_0[0] ? 1'b1 : 1'b0; // av_writedata_0[0]: 1'b0 by default
//assign fpga_led[1]          = av_writedata_0[1] ? 1'b1 : 1'b0; // av_writedata_0[0]: 1'b0 by default
//assign fpga_led[2]          = av_writedata_0[2] ? 1'b1 : 1'b0; // av_writedata_0[0]: 1'b0 by default
//assign fpga_led[3]          = av_writedata_0[3] ? 1'b1 : 1'b0; // av_writedata_0[0]: 1'b0 by default
//
assign fpga_led_status[0]  =  1'b1 ; // av_writedata_1[0]: 1'b0 by default
assign fpga_led_status[1]  =  1'b1 ; // av_writedata_1[1]: 1'b0 by default
assign fpga_led_status[2]  =  1'b1 ; // av_writedata_1[2]: 1'b0 by default
  sgpio_slave sgpio_slave_inst(
    .i_rstn     (global_resetn   ),
    .i_clk      (fpga_sgpio_clk  ),
    .i_sync     (fpga_sgpio_sync ),
    .i_mosi     (fpga_sgpi       ),
    .o_miso     (fpga_sgpo       ),
    .o_user_sw  (fpga_sw_pb         ),
    .i_user_led (fpga_led        )
  );
endmodule
	
