// (C) 2001-2024 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


#ifndef __PRBS_PATTERN_CHECKER_REGS_H__
#define __PRBS_PATTERN_CHECKER_REGS_H__


// individual 32-bit registers with byte addressing
#define PRBS_CHECKER_PAYLOAD_LENGTH_REG   					                0x0    /*    r/w    */
#define PRBS_CHECKER_CONTROL_REG                                    0x8    /*    r/w    */
#define PRBS_CHECKER_STATUS_REG                                     0xC    /*   r/clr   */
#define PRBS_CHECKER_POLYNOMIAL_31_0_REG                            0x10   /*    r/w    */
#define PRBS_CHECKER_POLYNOMIAL_63_32_REG                           0x14   /*    r/w    */
#define PRBS_CHECKER_POLYNOMIAL_95_64_REG                           0x18   /*    r/w    */
#define PRBS_CHECKER_POLYNOMIAL_127_96_REG                          0x1C   /*    r/w    */

// payload register
#define PRBS_CHECKER_PAYLOAD_LENGTH_MASK                            0xFFFFFFFF
#define PRBS_CHECKER_PAYLOAD_LENGTH_BYTE_OFFSET                     0
#define PRBS_CHECKER_PAYLOAD_LENGTH_BIT_OFFSET                      0


// control register
#define PRBS_CHECKER_INFINITE_PAYLOAD_LENGTH_ENABLE_MASK            0x00000001
#define PRBS_CHECKER_INFINITE_PAYLOAD_LENGTH_ENABLE_BYTE_OFFSET     0
#define PRBS_CHECKER_INFINITE_PAYLOAD_LENGTH_ENABLE_BIT_OFFSET      0

#define PRBS_CHECKER_STOP_ON_FAIL_MASK                              0x00000100
#define PRBS_CHECKER_STOP_ON_FAIL_BYTE_OFFSET                       1
#define PRBS_CHECKER_STOP_ON_FAIL_BIT_OFFSET                        8

#define PRBS_CHECKER_SEED_MASK                                      0x00010000
#define PRBS_CHECKER_SEED_BYTE_OFFSET                               2
#define PRBS_CHECKER_SEED_BIT_OFFSET                                16

#define PRBS_CHECKER_RUN_MASK                                       0x01000000
#define PRBS_CHECKER_RUN_BYTE_OFFSET                                3
#define PRBS_CHECKER_RUN_BIT_OFFSET                                 24


// status register
#define PRBS_CHECKER_FAILURE_DETECTED_MASK                          0x00000001
#define PRBS_CHECKER_FAILURE_DETECTED_BYTE_OFFSET                   0
#define PRBS_CHECKER_FAILURE_DETECTED_BIT_OFFSET                    0


// polynomial registers
#define PRBS_CHECKER_POLYNOMIAL_31_0_MASK                           0xFFFFFFFF
#define PRBS_CHECKER_POLYNOMIAL_31_0_BYTE_OFFSET                    0
#define PRBS_CHECKER_POLYNOMIAL_31_0_BIT_OFFSET                     0

#define PRBS_CHECKER_POLYNOMIAL_63_32_MASK                          0xFFFFFFFF
#define PRBS_CHECKER_POLYNOMIAL_63_32_BYTE_OFFSET                   0
#define PRBS_CHECKER_POLYNOMIAL_63_32_BIT_OFFSET                    0

#define PRBS_CHECKER_POLYNOMIAL_95_64_MASK                          0xFFFFFFFF
#define PRBS_CHECKER_POLYNOMIAL_95_64_BYTE_OFFSET                   0
#define PRBS_CHECKER_POLYNOMIAL_95_64_BIT_OFFSET                    0

#define PRBS_CHECKER_POLYNOMIAL_127_96_MASK                         0xFFFFFFFF
#define PRBS_CHECKER_POLYNOMIAL_127_96_BYTE_OFFSET                  0
#define PRBS_CHECKER_POLYNOMIAL_127_96_BIT_OFFSET                   0


#endif /* __PRBS_PATTERN_CHECKER_REGS_H__ */



