// (C) 2001-2024 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


#ifndef __PRBS_PATTERN_GENERATOR_H__
#define __PRBS_PATTERN_GENERATOR_H__


// public API to access the hardware
void prbs_generator_set_payload_length (unsigned long base, unsigned long length);
void prbs_generator_enable_infinite_payload_length (unsigned long base);
void prbs_generator_disable_infinite_payload_length (unsigned long base);
void prbs_generator_seed_enable (unsigned long base);
void prbs_generator_enable_start (unsigned long base);
void prbs_generator_disable_start (unsigned long base);
void prbs_generator_set_polynomial (unsigned long base, unsigned char *polynomial, long polynomial_length);

unsigned long prbs_generator_read_payload_length (unsigned long base);
unsigned char prbs_generator_read_infinite_payload_length (unsigned long base);
unsigned char prbs_generator_read_start (unsigned long base);
void prbs_generator_read_polynomial (unsigned long base, unsigned char *polynomial, long polynomial_length);


#endif /* __PRBS_PATTERN_GENERATOR_H__ */



