# (C) 2001-2024 Intel Corporation. All rights reserved.
# Your use of Intel Corporation's design tools, logic functions and other 
# software and tools, and its AMPP partner logic functions, and any output 
# files from any of the foregoing (including device programming or simulation 
# files), and any associated documentation or information are expressly subject 
# to the terms and conditions of the Intel Program License Subscription 
# Agreement, Intel FPGA IP License Agreement, or other applicable 
# license agreement, including, without limitation, that your use is for the 
# sole purpose of programming logic devices manufactured by Intel and sold by 
# Intel or its authorized distributors.  Please refer to the applicable 
# agreement for further details.


# TCL File Generated by Component Editor 20.1
# DO NOT MODIFY
# 
# prbs_pattern_checker "prbs_pattern_checker" v1.0
# A parallel data pattern checker that is controlled by an Avalon-MM slave
# 
# 
# request TCL package from ACDS 20.1
# 
package require -exact qsys 20.1
# 
# module prbs_pattern_checker
# 
set_module_property DESCRIPTION "A parallel data pattern checker that is controlled by an Avalon-MM slave"
set_module_property NAME prbs_pattern_checker
set_module_property VERSION 1.0
set_module_property INTERNAL false
set_module_property OPAQUE_ADDRESS_MAP true
set_module_property AUTHOR ""
set_module_property DISPLAY_NAME prbs_pattern_checker
set_module_property INSTANTIATE_IN_SYSTEM_MODULE true
set_module_property EDITABLE true
set_module_property REPORT_TO_TALKBACK false
set_module_property ALLOW_GREYBOX_GENERATION false
set_module_property REPORT_HIERARCHY false
set_module_property LOAD_ELABORATION_LIMIT 0
# 
# file sets
# 
add_fileset QUARTUS_SYNTH QUARTUS_SYNTH "" ""
set_fileset_property QUARTUS_SYNTH TOP_LEVEL prbs_pattern_checker
set_fileset_property QUARTUS_SYNTH ENABLE_RELATIVE_INCLUDE_PATHS false
set_fileset_property QUARTUS_SYNTH ENABLE_FILE_OVERWRITE_MODE false
add_fileset_file prbs_pattern_checker.v VERILOG PATH prbs_pattern_checker.v TOP_LEVEL_FILE
# 
# parameters
# 
add_parameter ST_DATA_W INTEGER 256
set_parameter_property ST_DATA_W DEFAULT_VALUE 256
set_parameter_property ST_DATA_W DISPLAY_NAME ST_DATA_W
set_parameter_property ST_DATA_W UNITS None
set_parameter_property ST_DATA_W ALLOWED_RANGES {32 40 50 64 66 80 128 256}
set_parameter_property ST_DATA_W HDL_PARAMETER true
add_parameter NUM_CYCLES_FOR_LOCK INTEGER 40
set_parameter_property NUM_CYCLES_FOR_LOCK DEFAULT_VALUE 40
set_parameter_property NUM_CYCLES_FOR_LOCK DISPLAY_NAME NUM_CYCLES_FOR_LOCK
set_parameter_property NUM_CYCLES_FOR_LOCK UNITS None
set_parameter_property NUM_CYCLES_FOR_LOCK HDL_PARAMETER true
add_parameter ST_TO_MM_SYNC_DEPTH INTEGER 2
set_parameter_property ST_TO_MM_SYNC_DEPTH DEFAULT_VALUE 2
set_parameter_property ST_TO_MM_SYNC_DEPTH DISPLAY_NAME ST_TO_MM_SYNC_DEPTH
set_parameter_property ST_TO_MM_SYNC_DEPTH UNITS None
set_parameter_property ST_TO_MM_SYNC_DEPTH HDL_PARAMETER true
add_parameter MM_TO_ST_SYNC_DEPTH INTEGER 2
set_parameter_property MM_TO_ST_SYNC_DEPTH DEFAULT_VALUE 2
set_parameter_property MM_TO_ST_SYNC_DEPTH DISPLAY_NAME MM_TO_ST_SYNC_DEPTH
set_parameter_property MM_TO_ST_SYNC_DEPTH UNITS None
set_parameter_property MM_TO_ST_SYNC_DEPTH HDL_PARAMETER true
# 
# display items
# 
# 
# connection point reset
# 
add_interface reset reset end
set_interface_property reset associatedClock clock
set_interface_property reset synchronousEdges DEASSERT
set_interface_property reset ENABLED true
set_interface_property reset EXPORT_OF ""
set_interface_property reset PORT_NAME_MAP ""
set_interface_property reset CMSIS_SVD_VARIABLES ""
set_interface_property reset SVD_ADDRESS_GROUP ""
set_interface_property reset IPXACT_REGISTER_MAP_VARIABLES ""
add_interface_port reset reset reset Input 1
# 
# connection point avalon_slave_0
# 
add_interface avalon_slave_0 avalon end
set_interface_property avalon_slave_0 addressGroup 0
set_interface_property avalon_slave_0 addressUnits WORDS
set_interface_property avalon_slave_0 associatedClock clock
set_interface_property avalon_slave_0 associatedReset reset
set_interface_property avalon_slave_0 bitsPerSymbol 8
set_interface_property avalon_slave_0 bridgedAddressOffset ""
set_interface_property avalon_slave_0 bridgesToMaster ""
set_interface_property avalon_slave_0 burstOnBurstBoundariesOnly false
set_interface_property avalon_slave_0 burstcountUnits WORDS
set_interface_property avalon_slave_0 explicitAddressSpan 0
set_interface_property avalon_slave_0 holdTime 0
set_interface_property avalon_slave_0 linewrapBursts false
set_interface_property avalon_slave_0 maximumPendingReadTransactions 0
set_interface_property avalon_slave_0 maximumPendingWriteTransactions 0
set_interface_property avalon_slave_0 minimumResponseLatency 1
set_interface_property avalon_slave_0 readLatency 0
set_interface_property avalon_slave_0 readWaitTime 1
set_interface_property avalon_slave_0 setupTime 0
set_interface_property avalon_slave_0 timingUnits Cycles
set_interface_property avalon_slave_0 transparentBridge false
set_interface_property avalon_slave_0 waitrequestAllowance 0
set_interface_property avalon_slave_0 writeWaitTime 0
set_interface_property avalon_slave_0 ENABLED true
set_interface_property avalon_slave_0 EXPORT_OF ""
set_interface_property avalon_slave_0 PORT_NAME_MAP ""
set_interface_property avalon_slave_0 CMSIS_SVD_VARIABLES ""
set_interface_property avalon_slave_0 SVD_ADDRESS_GROUP ""
set_interface_property avalon_slave_0 IPXACT_REGISTER_MAP_VARIABLES ""
add_interface_port avalon_slave_0 avs_address address Input 3
add_interface_port avalon_slave_0 avs_write write Input 1
add_interface_port avalon_slave_0 avs_read read Input 1
add_interface_port avalon_slave_0 avs_byteenable byteenable Input 4
add_interface_port avalon_slave_0 avs_writedata writedata Input 32
add_interface_port avalon_slave_0 avs_readdata readdata Output 32
set_interface_assignment avalon_slave_0 embeddedsw.configuration.isFlash 0
set_interface_assignment avalon_slave_0 embeddedsw.configuration.isMemoryDevice 0
set_interface_assignment avalon_slave_0 embeddedsw.configuration.isNonVolatileStorage 0
set_interface_assignment avalon_slave_0 embeddedsw.configuration.isPrintableDevice 0
# 
# connection point clock
# 
add_interface clock clock end
set_interface_property clock ENABLED true
set_interface_property clock EXPORT_OF ""
set_interface_property clock PORT_NAME_MAP ""
set_interface_property clock CMSIS_SVD_VARIABLES ""
set_interface_property clock SVD_ADDRESS_GROUP ""
set_interface_property clock IPXACT_REGISTER_MAP_VARIABLES ""
add_interface_port clock avs_clk clk Input 1
# 
# connection point conduit_pattern_in
# 
add_interface conduit_pattern_in conduit end
set_interface_property conduit_pattern_in associatedClock ""
set_interface_property conduit_pattern_in associatedReset ""
set_interface_property conduit_pattern_in ENABLED true
set_interface_property conduit_pattern_in EXPORT_OF ""
set_interface_property conduit_pattern_in PORT_NAME_MAP ""
set_interface_property conduit_pattern_in CMSIS_SVD_VARIABLES ""
set_interface_property conduit_pattern_in SVD_ADDRESS_GROUP ""
set_interface_property conduit_pattern_in IPXACT_REGISTER_MAP_VARIABLES ""
add_interface_port conduit_pattern_in asi_data export Input "((ST_DATA_W - 1)) - (0) + 1"
# 
# connection point conduit_clk_in
# 
add_interface conduit_clk_in conduit end
set_interface_property conduit_clk_in associatedClock ""
set_interface_property conduit_clk_in associatedReset ""
set_interface_property conduit_clk_in ENABLED true
set_interface_property conduit_clk_in EXPORT_OF ""
set_interface_property conduit_clk_in PORT_NAME_MAP ""
set_interface_property conduit_clk_in CMSIS_SVD_VARIABLES ""
set_interface_property conduit_clk_in SVD_ADDRESS_GROUP ""
set_interface_property conduit_clk_in IPXACT_REGISTER_MAP_VARIABLES ""
add_interface_port conduit_clk_in asi_clk export Input 1
