`timescale 1ns / 100ps

module  golden_top (
        //Reset&Clock
        input  wire        cpu_1v2_resetn          , // Reset, low active
        input  wire        clk_sys_100m_p          , // System clock, 100MHz
        input  wire        clk_sys_bak_100m_p       , // System clock, 50MHz
        //I2C interfaces
	    inout  wire        si5518_i2c_scl           , // FPGA I2C interface #1 SCL
        inout  wire        si5518_i2c_sda           , // FPGA I2C interface #1 SDA
        //RDIMM I2C interfaces 
		inout  wire        fpga_dimm_scl            , // FPGA I2C interface #2 SCL
        inout  wire        fpga_dimm_sda            , // FPGA I2C interface #2 SDA
        //i2c 2
		inout  wire        si5395_i2c_scl           , // FPGA I2C interface
        inout  wire        si5395_i2c_sda           , // FPGA I2C interface
        //i2c 3
		inout  wire        fmca_i2c_scl             , // FPGA I2C interface
        inout  wire        fmca_i2c_sda             , // FPGA I2C interface
        //i2c 4 
		inout  wire        fmcb_i2c_scl             , // FPGA I2C interface
        inout  wire        fmcb_i2c_sda             , // FPGA I2C interface
        //i2c 5
		inout  wire        pca95350_i2c_scl           , // FPGA I2C interface 
        inout  wire        pca95350_i2c_sda           , // FPGA I2C interface 
        //i2c 6 
		inout  wire        pca95351_i2c_scl           , // FPGA I2C interface 
        inout  wire        pca95351_i2c_sda           , // FPGA I2C interface 
        //i2c 7-14
		inout  wire        qsfp0_i2c_scl           , // FPGA I2C interface
        inout  wire        qsfp0_i2c_sda           , // FPGA I2C interface
		inout  wire        qsfp1_i2c_scl           , // FPGA I2C interface
        inout  wire        qsfp1_i2c_sda           , // FPGA I2C interface
		inout  wire        qsfp2_i2c_scl           , // FPGA I2C interface
        inout  wire        qsfp2_i2c_sda           , // FPGA I2C interface
		inout  wire        osfp_i2c_scl            , // FPGA I2C interface
        inout  wire        osfp_i2c_sda            , // FPGA I2C interface
		inout  wire        sfp0_i2c_scl            , // FPGA I2C interface
        inout  wire        sfp0_i2c_sda            , // FPGA I2C interface
		inout  wire        sfp1_i2c_scl            , // FPGA I2C interface
        inout  wire        sfp1_i2c_sda            , // FPGA I2C interface
		inout  wire        sfp2_i2c_scl            , // FPGA I2C interface
        inout  wire        sfp2_i2c_sda            , // FPGA I2C interface
		inout  wire        sfp3_i2c_scl            , // FPGA I2C interface
        inout  wire        sfp3_i2c_sda            , // FPGA I2C interface
        //SPI 
	    input  wire        spi_5518_MISO,   
        output wire        spi_5518_MOSI,   
        output wire        spi_5518_SCLK,   
        output wire        spi_5518_SS_n,   
		//SGPIO for dipsw, leds
        input  wire        fpga_sgpio_sync,
        input  wire        fpga_sgpio_clk ,
        input  wire        fpga_sgpi      ,    
        output wire        fpga_sgpo      ,
        //For RevA board only
		output wire        si5395_1_1v2_a_oen        ,
		output wire        si5395_2_1v2_a_oen        ,
        //GPIOs
	    output wire [11:0] fpga_gpio,                 // FPGA user LEDs
//EMIF comp interface
        input  wire        DDR4_COMP_2_REFCLKP,           //                                  .clk
		output wire        DDR4_COMP_2_CKP,               //                                  .mem_ck
		output wire        DDR4_COMP_2_CKN,               //                                  .mem_ck_n
		output wire [16:0] DDR4_COMP_2_A,                 //                                  .mem_a
		output wire        DDR4_COMP_2_ACTN,              //                                  .mem_act_n
		output wire [1:0]  DDR4_COMP_2_BA,                //                                  .mem_ba
		output wire [1:0]  DDR4_COMP_2_BG,                //                                  .mem_bg		   
		output wire        DDR4_COMP_2_CKE,               //                                  .mem_cke
		output wire        DDR4_COMP_2_CSN,               //                                  .mem_cs_n
		output wire        DDR4_COMP_2_ODT,               //                                  .mem_odt
		output wire        DDR4_COMP_2_RSTN,              //                                  .mem_reset_n
		output wire        DDR4_COMP_2_PAR,               //                                  .mem_par
		input  wire        DDR4_COMP_2_ALERTN,            //                                  .mem_alert_n
		inout  wire [8:0]  DDR4_COMP_2_DQSP,              //                                  .mem_dqs
		inout  wire [8:0]  DDR4_COMP_2_DQSN,              //                                  .mem_dqs_n
		inout  wire [71:0] DDR4_COMP_2_DQ,                //                                  .mem_dq               
		inout  wire [8:0]  DDR4_COMP_2_DBI,               //                                  .mem_dq               
	    input  wire        DDR4_COMP_2_RZQ,               //                                  .rzqin
//EMIF DIMM interface
        input  wire        DDR4_DIMM_1_REFCLKP,           //                                  .clk
		output wire        DDR4_DIMM_1_CKP,               //                                  .mem_ck
		output wire        DDR4_DIMM_1_CKN,               //                                  .mem_ck_n
		output wire [16:0] DDR4_DIMM_1_A,                 //                                  .mem_a
		output wire        DDR4_DIMM_1_ACTN,              //                                  .mem_act_n
		output wire [1:0]  DDR4_DIMM_1_BA,                //                                  .mem_ba
		output wire [1:0]  DDR4_DIMM_1_BG,                //                                  .mem_bg	
		output wire        DDR4_DIMM_1_CKE,               //                                  .mem_cke
		output wire        DDR4_DIMM_1_CSN,               //                                  .mem_cs_n
		output wire        DDR4_DIMM_1_ODT,               //                                  .mem_odt
		output wire        DDR4_DIMM_1_RSTN,              //                                  .mem_reset_n
		output wire        DDR4_DIMM_1_PAR,               //                                  .mem_par
		input  wire        DDR4_DIMM_1_ALERTN,            //                                  .mem_alert_n
		inout  wire [17:0] DDR4_DIMM_1_DQSP,              //                                  .mem_dqs
		inout  wire [17:0] DDR4_DIMM_1_DQSN,              //                                  .mem_dqs_n
		inout  wire [71:0] DDR4_DIMM_1_DQ,                //                                  .mem_dq               
 	    input  wire        DDR4_DIMM_1_RZQ,               //                                  .oct_rzqin
   
//QSFP XCVR channels
        input  wire [3:0]  qsfp0_rx_p          , // QSFP #0 RX P
        input  wire [3:0]  qsfp0_rx_n          , // QSFP #0 RX N
        output wire [3:0]  qsfp0_tx_p          , // QSFP #0 TX P
        output wire [3:0]  qsfp0_tx_n          , // QSFP #0 TX N
        input  wire [3:0]  qsfp1_rx_p          , // QSFP #1 RX P
        input  wire [3:0]  qsfp1_rx_n          , // QSFP #1 RX N
        output wire [3:0]  qsfp1_tx_p          , // QSFP #1 TX P
        output wire [3:0]  qsfp1_tx_n          , // QSFP #1 TX N
        input  wire [3:0]  qsfp2_rx_p          , // QSFP #2 RX P
        input  wire [3:0]  qsfp2_rx_n          , // QSFP #2 RX N
        output wire [3:0]  qsfp2_tx_p          , // QSFP #2 TX P
        output wire [3:0]  qsfp2_tx_n          , // QSFP #2 TX N

//SFP XCVR channels
        output wire [3:0]  sfp_tx_n            ,
        output wire [3:0]  sfp_tx_p            ,
        input wire  [3:0]  sfp_rx_n            ,
        input wire  [3:0]  sfp_rx_p            ,

//QSFPDD800 XCVR channels
        input  wire        clk_fgt_12b      ,
        input  wire        clk_fht_12b      ,
        input  wire        clk_fgt_12c      ,
        input  wire        clk_fht_12c      ,
		output wire [7:0]  qsfpdd800_tx_p   ,	
        output wire [7:0]  qsfpdd800_tx_n	,
        input  wire  [7:0] qsfpdd800_rx_p   ,	
        input  wire  [7:0] qsfpdd800_rx_n	,
//OSFP XCVR channels
        input  wire        clk_fgt_13b      ,
        input  wire        clk_fht_13b      ,
        input  wire        clk_fgt_13c      ,
        input  wire        clk_fht_13c      ,
		output wire [7:0]  osfp_tx_p        ,	
        output wire [7:0]  osfp_tx_n	    ,
        input  wire  [7:0] osfp_rx_p        ,	
        input  wire  [7:0] osfp_rx_n	    ,
//fmca
        //QSFPDD XCVR channels 
        input  wire [15:0]  fmca_a_rx_p          , // FMCA RX P
        input  wire [15:0]  fmca_a_rx_n          , // FMCA RX N
        output wire [15:0]  fmca_a_tx_p          , // FMCA TX P
        output wire [15:0]  fmca_a_tx_n          , // FMCA TX N
        
		//COMS Interface		      
        //input             fa_alan0             , // input,  lvds/cmos loopback test is not supported, input clock from loopback card
        //input             fa_alap0             , // input,  lvds/cmos loopback test is not supported, input clock from loopback card
        //output            fa_alan1             , // output, lvds/cmos loopback test is not supported, output clock to loopback card
        //output            fa_alap1             , // output, lvds/cmos loopback test is not supported, output clock to loopback card 
        input  wire         fa_alan2             ,
        input  wire         fa_alap2             ,
        output wire         fa_alan3             ,
        output wire         fa_alap3             ,
        input  wire         fa_alan4             ,
        input  wire         fa_alap4             ,
        input  wire         fa_alan5             ,
        input  wire         fa_alap5             ,
        output wire         fa_alan6             ,
        output wire         fa_alap6             ,
        input  wire         fa_alan7             ,
        input  wire         fa_alap7             ,
        output wire         fa_alan8             ,
        output wire         fa_alap8             ,
        input  wire         fa_alan9             ,
        input  wire         fa_alap9             ,
        output wire         fa_alan10            ,
        output wire         fa_alap10            ,
        input  wire         fa_alan11            ,
        input  wire         fa_alap11            ,
        output wire         fa_alan12            ,
        output wire         fa_alap12            ,
        input  wire         fa_alan13            ,
        input  wire         fa_alap13            ,
        output wire         fa_alan14            ,
        output wire         fa_alap14            ,
        input  wire         fa_alan15            ,
        input  wire         fa_alap15            ,
        output wire         fa_alan16            ,
        output wire         fa_alap16            ,
        input  wire         fa_alan17            ,
        input  wire         fa_alap17            ,
        output wire         fa_alan18            ,
        output wire         fa_alap18            ,
        input  wire         fa_alan19            ,
        input  wire         fa_alap19            ,
        output wire         fa_alan20            ,
        output wire         fa_alap20            ,
        input  wire         fa_alan21            ,
        input  wire         fa_alap21            ,
        output wire         fa_alan22            ,
        output wire         fa_alap22            ,
        input  wire         fa_alan23            ,
        input  wire         fa_alap23            ,
        input  wire         fa_alan24            ,
        input  wire         fa_alap24            ,
        output wire         fa_alan25            ,
        output wire         fa_alap25            ,
        input  wire         fa_alan26            ,
        input  wire         fa_alap26            ,
        output wire         fa_alan27            ,
        output wire         fa_alap27            ,
        input  wire         fa_alan28            ,
        input  wire         fa_alap28            ,
        output wire         fa_alan29            ,
        output wire         fa_alap29            ,
        input  wire         fa_alan30            ,
        input  wire         fa_alap30            ,
        output wire         fa_alan31            ,
        output wire         fa_alap31            ,
        output wire         fa_alan32            ,
        output wire         fa_alap32            ,
        output wire         fa_alan33            ,
        output wire         fa_alap33            ,
//fmcb
        //QSFPDD XCVR channels 
        input  wire [15:0]  fmca_b_rx_p          , // FMCA RX P
        input  wire [15:0]  fmca_b_rx_n          , // FMCA RX N
        output wire [15:0]  fmca_b_tx_p          , // FMCA TX P
        output wire [15:0]  fmca_b_tx_n          , // FMCA TX N
        
		//COMS Interface		      
        //input             fa_blan0             , // input,  lvds/cmos loopback test is not supported, input clock from loopback card
        //input             fa_blap0             , // input,  lvds/cmos loopback test is not supported, input clock from loopback card
        //output            fa_blan1             , // output, lvds/cmos loopback test is not supported, output clock to loopback card
        //output            fa_blap1             , // output, lvds/cmos loopback test is not supported, output clock to loopback card 
        input  wire         fa_blan2             ,
        input  wire         fa_blap2             ,
        output wire         fa_blan3             ,
        output wire         fa_blap3             ,
        input  wire         fa_blan4             ,
        input  wire         fa_blap4             ,
        input  wire         fa_blan5             ,
        input  wire         fa_blap5             ,
        output wire         fa_blan6             ,
        output wire         fa_blap6             ,
        input  wire         fa_blan7             ,
        input  wire         fa_blap7             ,
        output wire         fa_blan8             ,
        output wire         fa_blap8             ,
        input  wire         fa_blan9             ,
        input  wire         fa_blap9             ,
        output wire         fa_blan10            ,
        output wire         fa_blap10            ,
        input  wire         fa_blan11            ,
        input  wire         fa_blap11            ,
        output wire         fa_blan12            ,
        output wire         fa_blap12            ,
        input  wire         fa_blan13            ,
        input  wire         fa_blap13            ,
        output wire         fa_blan14            ,
        output wire         fa_blap14            ,
        input  wire         fa_blan15            ,
        input  wire         fa_blap15            ,
        output wire         fa_blan16            ,
        output wire         fa_blap16            ,
        input  wire         fa_blan17            ,
        input  wire         fa_blap17            ,
        output wire         fa_blan18            ,
        output wire         fa_blap18            ,
        input  wire         fa_blan19            ,
        input  wire         fa_blap19            ,
        output wire         fa_blan20            ,
        output wire         fa_blap20            ,
        input  wire         fa_blan21            ,
        input  wire         fa_blap21            ,
        output wire         fa_blan22            ,
        output wire         fa_blap22            ,
        input  wire         fa_blan23            ,
        input  wire         fa_blap23            ,
        input  wire         fa_blan24            ,
        input  wire         fa_blap24            ,
        output wire         fa_blan25            ,
        output wire         fa_blap25            ,
        input  wire         fa_blan26            ,
        input  wire         fa_blap26            ,
        output wire         fa_blan27            ,
        output wire         fa_blap27            ,
        input  wire         fa_blan28            ,
        input  wire         fa_blap28            ,
        output wire         fa_blan29            ,
        output wire         fa_blap29            ,
        input  wire         fa_blan30            ,
        input  wire         fa_blap30            ,
        output wire         fa_blan31            ,
        output wire         fa_blap31            ,
        output wire         fa_blan32            ,
        output wire         fa_blap32            ,
        output wire         fa_blan33            ,
        output wire         fa_blap33            ,
//qsfpdd start
        input  wire        qsfpdd0_clk    , // QSFPDD1 reference clock 156.25MHz  
        input  wire        qsfpdd1_clk    , // QSFPDD1 reference clock 156.25MHz  
		input  wire        qsfpdd2_clk    , // QSFPDD0 reference clock 156.25MHz 
		input  wire        qsfpdd3_clk    , // QSFPDD0 reference clock 156.25MHz 
//QSFPDD XCVR channels
        input  wire [7:0]  qsfpdd0_rx_p          , // QSFPDD #0 RX P
        input  wire [7:0]  qsfpdd0_rx_n          , // QSFPDD #0 RX N
        output wire [7:0]  qsfpdd0_tx_p          , // QSFPDD #0 TX P
        output wire [7:0]  qsfpdd0_tx_n          , // QSFPDD #0 TX N
        input  wire [7:0]  qsfpdd1_rx_p          , // QSFPDD #1 RX P
        input  wire [7:0]  qsfpdd1_rx_n          , // QSFPDD #1 RX N
        output wire [7:0]  qsfpdd1_tx_p          , // QSFPDD #1 TX P
        output wire [7:0]  qsfpdd1_tx_n          , // QSFPDD #1 TX N
        input  wire [7:0]  qsfpdd2_rx_p          , // QSFPDD #2 RX P
        input  wire [7:0]  qsfpdd2_rx_n          , // QSFPDD #2 RX N
        output wire [7:0]  qsfpdd2_tx_p          , // QSFPDD #2 TX P
        output wire [7:0]  qsfpdd2_tx_n          , // QSFPDD #2 TX N
        input  wire [7:0]  qsfpdd3_rx_p          , // QSFPDD #3 RX P
        input  wire [7:0]  qsfpdd3_rx_n          , // QSFPDD #3 RX N
        output wire [7:0]  qsfpdd3_tx_p          , // QSFPDD #3 TX P
        output wire [7:0]  qsfpdd3_tx_n            // QSFPDD #3 TX N

        );
endmodule
